
// Programm 'schei Bild' konvertiert Text in Bilder, um automatisches Lesen zu erschweren
// program 'fucking picture' to convert text to picture to avoid automatic reading
// copyright = 'copyright (c) Carsten Thumulla 2014, Version 0.11 under GPLv3';

unit FP;

interface

uses
  Classes, Controls, Forms, Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls,
  IniFiles, Types;

type
  TFPForm                           = class(TForm)
    Memo                            : TMemo;
    PopMenu                         : TPopupMenu;
    LoadDialog                      : TOpenDialog;
    SaveDialog                      : TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LoadFileClick(Sender: TObject);
    procedure SaveFileClick(Sender: TObject);
    procedure SaveLoadDeleteClick(Sender: TObject);
    procedure SetupClick(Sender: TObject);
    procedure ConvertClick(Sender: TObject);
    procedure ConvertOneClick(Sender: TObject);
    procedure ConvertFileClick(Sender: TObject);
    procedure DokuClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
  end;

const
  copyright = 'copyright (c) Carsten Thumulla 2014, Version 0.11 under GPLv3';

var
  FPForm                            : TFPForm;

implementation

{$R *.dfm}

uses FPImage, FPSetup, FPSaveLoad, Setup;

procedure TFPForm.FormCreate(Sender: TObject);
var NewItem               : TMenuItem;
begin
  Caption := 'Editorfenster';
  KeyPreview := True;


  Memo.Align := alClient;
  Memo.PopupMenu := PopMenu;
  //Memo.ScrollBars := ssVertical;

  Setup.spFont := Memo.Font;

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'load text';
  NewItem.OnClick := LoadFileClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'save text';
  NewItem.OnClick := SaveFileClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'save load delete';
  NewItem.OnClick := SaveLoadDeleteClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'show setup';
  NewItem.OnClick := SetupClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'convert';
  NewItem.OnClick := ConvertClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'convert to one picture';
  NewItem.OnClick := ConvertOneClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'convert from file';
  NewItem.OnClick := ConvertFileClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'doku';
  NewItem.OnClick := DokuClick;
  PopMenu.Items.Add(NewItem);

  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := 'quit';
  NewItem.OnClick := QuitClick;
  PopMenu.Items.Add(NewItem);

  MemSetFile := TMemIniFile.Create(SetupFileName);
  try
    Left := MemSetFile.ReadInteger(ProgSetup, WinEditLeft, 50);
    Top := MemSetFile.ReadInteger(ProgSetup, WinEditTop, 50);
    Width := MemSetFile.ReadInteger(ProgSetup, WinEditWidth, 300);
    Height := MemSetFile.ReadInteger(ProgSetup, WinEditHeight, 400);
  finally
    MemSetFile.Free;
  end;

  try
    SetLoad(StandardSetup);
  except end;

  // nur test
  try
    Memo.Lines.LoadFromFile('lore_ipsum.txt');
  except end;
end;

procedure TFPForm.FormActivate(Sender: TObject);
begin
  try
    FPForm.Memo.Color := spBgColor;
    FPForm.Memo.Font.Color := spFont.Color;
  except end;
end;

procedure TFPForm.LoadFileClick(Sender: TObject);
begin
  LoadDialog.Title := 'Datei laden';
  if LoadDialog.Execute then Memo.Lines.LoadFromFile(LoadDialog.FileName);
end;

procedure TFPForm.SaveFileClick(Sender: TObject);
begin
  LoadDialog.Title := 'Datei speichern';
  if LoadDialog.Execute then Memo.Lines.SaveToFile(SaveDialog.FileName);
end;

procedure TFPForm.SaveLoadDeleteClick(Sender: TObject);
begin
  FPSaveLoadForm.Show;
end;

procedure TFPForm.SetupClick(Sender: TObject);
begin
  FPSetupForm.Show;
end;

procedure TFPForm.ConvertClick(Sender: TObject);
begin
  FPImageForm.Image.Picture := nil; // clear / lschen
  FPImageForm.Image.Width   := Memo.Width + Memo.Font.Size;
  FPImageForm.Image.Height  := Memo.Height;
  FPImageForm.ClientHeight  := FPImageForm.Image.Height;
  // insert here the interface to transport clear text to NSA
  spFont.Size := Memo.Font.Size;
  TextAusg(Memo.Text, FPImageForm.Image, FPImageForm, False);
  FPImageForm.Show;
end;

procedure TFPForm.ConvertOneClick(Sender: TObject);
begin
  FPImageForm.Image.Picture := nil; // clear / lschen
  FPImageForm.Image.Width   := Memo.Width + Memo.Font.Size;
  FPImageForm.Image.Height  := Memo.Height;
  FPImageForm.ClientHeight  := FPImageForm.Image.Height;
  // insert here the interface to transport clear text to NSA
  spFont.Size := Memo.Font.Size;
  TextAusg(Memo.Text, FPImageForm.Image, FPImageForm, True);
  FPImageForm.Show;
end;

procedure TFPForm.ConvertFileClick(Sender: TObject);
var   FileText            : TStringList;
begin
  if LoadDialog.Execute then begin
    FPImageForm.Image.Picture := nil; // clear / lschen
    FPImageForm.Image.Width   := Memo.Width + Memo.Font.Size;
    FPImageForm.Image.Height  := Memo.Height;
    // insert here the interface to transport clear text to NSA
    FileText := TStringList.Create; 
    try
      FileText.LoadFromFile(LoadDialog.FileName);
      TextAusg(FileText.Text, FPImageForm.Image, FPImageForm, False);
    finally
      FileText.Free;
    end;
    FPImageForm.Show;
  end;
end;

procedure TFPForm.DokuClick(Sender: TObject);
begin
  try
    Memo.Lines.LoadFromFile('Dokumentation.txt');
  except end;
end;

procedure TFPForm.QuitClick(Sender: TObject);
begin
  close;
end;

procedure TFPForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    65 :  if (ssCtrl in Shift) then Memo.SelectAll;
  end;
end;

procedure TFPForm.FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  if (ssCtrl in Shift) then Memo.Font.Size := Memo.Font.Size + 1;
end;

procedure TFPForm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  if (ssCtrl in Shift) and (Memo.Font.Size > 1) then Memo.Font.Size := Abs(Memo.Font.Size) - 1;
end;

end.


