unit FPSaveLoad;

interface

uses
  Classes, Controls, Forms, StdCtrls, ExtCtrls, IniFiles, SysUtils;

type
  TFPSaveLoadForm                   = class(TForm)
    Panel                           : TPanel;
    ComboBox                        : TComboBox;
    BtnSave                         : TButton;
    BtnLoad                         : TButton;
    BtnDelete                       : TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure BtnLoadClick(Sender: TObject);
    procedure BtnDeleteClick(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
  end;

var
  FPSaveLoadForm                    : TFPSaveLoadForm;

implementation

{$R *.dfm}

uses FP, FPSetup, Setup;

procedure TFPSaveLoadForm.FormCreate(Sender: TObject);
begin
  Caption := 'Fenster Einstellungen verwalten';

  AutoSize := True;
  BorderStyle := bsDialog;

  MemSetFile := TMemIniFile.Create(SetupFileName);
  try
    Left := MemSetFile.ReadInteger(ProgSetup, WinSaveLoadLeft, 150);
    Top := MemSetFile.ReadInteger(ProgSetup, WinSaveLoadTop, 250);
  finally
    MemSetFile.Free;
  end;

  ComboBox.OnChange := ComboBoxChange;
  BtnSave.OnClick := BtnSaveClick;
  BtnLoad.OnClick := BtnLoadClick;
  BtnDelete.OnClick := BtnDeleteClick;
end;

procedure TFPSaveLoadForm.FormActivate(Sender: TObject);
begin
  MemSetFile := TMemIniFile.Create(SetupFileName);
  try
    MemSetFile.ReadSections(ComboBox.Items);
  finally
    MemSetFile.Free;
  end;
  ComboBox.SetFocus;
end;

procedure TFPSaveLoadForm.BtnSaveClick(Sender: TObject);
begin
  Setup.SetSave(ComboBox.Text);
  Close;
end;

procedure TFPSaveLoadForm.BtnLoadClick(Sender: TObject);
begin
  Setup.SetLoad(ComboBox.Text);
  FPForm.FormActivate(Self);
  FPSetupForm.FormActivate(Self);
  Caption := ComboBox.Text;
  Close;
end;

procedure TFPSaveLoadForm.BtnDeleteClick(Sender: TObject);
begin
  MemSetFile := TMemIniFile.Create(SetupFileName);
  try
    (*
    MemSetFile.EraseSection(ComboBox.Items[ComboBox.Itemindex]);
    MemSetFile.UpdateFile;
    ComboBox.Items.Delete(ComboBox.Itemindex);
      *)
    MemSetFile.EraseSection(ComboBox.Text);
    MemSetFile.UpdateFile;
    ComboBox.Text := '';
    MemSetFile.ReadSections(ComboBox.Items);
  finally
    MemSetFile.Free;
  end;
end;

procedure TFPSaveLoadForm.ComboBoxChange(Sender: TObject);
begin
  BtnSave.Enabled := not (ComboBox.Items[ComboBox.Itemindex] = ProgSetup);
  BtnLoad.Enabled := not (ComboBox.Items[ComboBox.Itemindex] = ProgSetup);
end;

end.


