unit konvpng; // Konvertierung Bitmap in png

interface

uses
  SysUtils, QGraphics;

type
  TString = string;
  procedure KonvertPng(QuellBild, ZielBild : String);

implementation

procedure KonvertPng(QuellBild, ZielBild : String);
var   Bmp                 : TBitMap;
begin
// VCL
// pfDevice  Die Grafik wird als gerteabhngiges Bitmap gespeichert.
// pf1bit    Gerteunabhngiges Bitmap mit einem Bit pro Pixel (Schwarzwei-Palette).
// pf4bit    Gerteunabhngiges Bitmap, das eine Palette mit 16 Farben verwendet.
// pf8bit    Gerteunabhngiges Bitmap, das eine Palette mit 256 Farben verwendet.
// pf15bit   Gerteunabhngiges True-Color-Bitmap mit 15 Bits pro Pixel (RGB-Komprimierung).
// pf16bit   Gerteunabhngiges True-Color-Bitmap mit 16 Bits pro Pixel (Bitfeld-Komprimierung).
// pf24bit   Gerteunabhngiges True-Color-Bitmap mit 24 Bits pro Pixel.
// pf32bit   Gerteunabhngiges True-Color-Bitmap mit 32 Bits pro Pixel (RGB-Komprimierung).
// pfCustom  Anderes Format. pfCustom wird von TBitmap nicht untersttzt.

// CLX
// pf1bit    Gerteunabhngiges Bitmap mit einem Bit pro Pixel (Schwarzwei-Palette).
// pf8bit    Gerteunabhngiges Bitmap, das eine Palette mit 256 Farben verwendet.
// pf16bit   Gerteunabhngiges True-Color-Bitmap mit 16 Bits pro Pixel.
// pf32bit   Gerteunabhngiges True-Color-Bitmap mit 32 Bits pro Pixel.
// pfCustom  Anderes Format.

  Bmp := TBitMap.Create;
  try
    Bmp.LoadFromFile(QuellBild);
    Bmp.Format := 'PNG';
    Bmp.SaveToFile(ZielBild);
    DeleteFile(QuellBild)
  finally
    Bmp.Free;
  end;
end;

end.


